/*
 * BOX OFFICES for iPhone/iPad
 *
 * The Original Game is Designed by Entatonic.net
 * Copyright (c) 2010 Entatonic.net
 * http://entatonic.net
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */



#import "BoxExplosion.h"
#import "CCTextureCache.h"
#import "CCDirector.h"
#import "iPhone_iPad_Selector.h"

@implementation BoxExplosion
-(id) init
{
	return [self initWithTotalParticles:200];	
}

-(id) initWithTotalParticles:(int)p
{
	if( !(self=[super initWithTotalParticles:p]) )
		return nil;
	
	// duration
	duration = 0.1f;
	
	// gravity
	mode.A.gravity.x = 0;
	mode.A.gravity.y = -200;
	
	// angle
	angle = 90;
	angleVar = 360;
	
	// speed of particles
	mode.A.speed = 100 * iPhone_iPad;
	mode.A.speedVar = 100 * iPhone_iPad;
	
	// radial
	mode.A.radialAccel = 0;
	mode.A.radialAccelVar = 0;
	
	// tagential
	mode.A.tangentialAccel = 0;
	mode.A.tangentialAccelVar = 0;

	// position of the node
	CGPoint position;	// ****************** TO AVOID COMPILE ERROR
	
	// emitter position
	position.x = 160;
	position.y = 240;
	posVar.x = 0;
	posVar.y = 0;
	
	// life of particles
	life = 10.0f;
	lifeVar = 2;
	
	// size, in pixels
	startSize = 20.0f * iPhone_iPad;
	startSizeVar = 20.0f * iPhone_iPad;
	
	// emits per second
	emissionRate = totalParticles/duration;
	
	// color of particles
	startColor.r = 1.0f;
	startColor.g = 1.0f;
	startColor.b = 1.0f;
	startColor.a = 1.0f;
	startColorVar.r = 0.0f;
	startColorVar.g = 0.0f;
	startColorVar.b = 0.0f;
	startColorVar.a = 0.0f;
	endColor.r = 0.0f;
	endColor.g = 0.0f;
	endColor.b = 0.0f;
	endColor.a = 0.0f;
	endColorVar.r = 0.0f;
	endColorVar.g = 0.0f;
	endColorVar.b = 0.0f;
	endColorVar.a = 0.0f;
	
	//	self.texture = [[TextureMgr sharedTextureMgr] addImage: @"CHARA1.PNG"];
	
	// additive
//	blendAdditive = NO;
	[self setBlendAdditive:FALSE];
	
	return self;
}

@end
