/*
 * BOX OFFICES for iPhone/iPad
 *
 * The Original Game is Designed by Entatonic.net
 * Copyright (c) 2010 Entatonic.net
 * http://entatonic.net
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */



#import <Foundation/Foundation.h>
#import "boxObject.h"
#import "cocos2d.h"
#import "StageManager.h"

#define LAUNCHER_INTERVAL 25
#define LAUNCHER_ANIMATION_DIRECTION -25
#define MOMENT_COUNTER_FORANGLE 20
#define BOXExpand_interval 120
#define AUTO_RELEASE_BOX_SIDE 70	// %
#define LAUNCHING_BOX_SIZE 20 /*%*/

@interface Launcher : NSObject {
	cpSpace *m_space;
	NSMutableArray			*listOnlauncher;			// Object list on launcher
	int		m_move_offset;		// 0: center
	int		moment_counter;
	int		moment_vx;
	int		boxExpand_interval_counter;
	int		launchingBox_size;
	int		init_launchingBox_size;
	BOOL	expiredLauncher_MoveLauncherToLeft;
	
	int display_width;
	int display_height;
	int display_width_center;
	int display_height_launcher_y;
	

	int LauncherExpandSpeedRate;	// 0-100%
}

-(id) initWithcpSpace: (cpSpace *) space;

-(void) resetLauncher;
-(void) moveLauncherLeft;
-(void) moveLauncherListLeft;
-(void) addOboxObject:(boxObject*) box;
-(void) setLaunchingBoxScale;
-(BOOL) launchBox_vx:(float)launcher_vx vy:(float)launcher_vy;
-(BOOL) expiredLauncher_MoveLauncherToLeft;	// NEW
-(boxObject*) stepAnimation:(StageManager *) stageManager;
-(boxObject *) getboxObjectIndex:(int) index;
-(void) setLauncherExpandSpeedRate:(int) rate;
-(float) getXFromIndex:(int) i;
-(float) getYFromIndex:(int) i;
-(int) getNumOfObjects;


@property(nonatomic, retain) NSMutableArray	*listOnlauncher;

@end
