/*
 * BOX OFFICES for iPhone/iPad
 *
 * The Original Game is Designed by Entatonic.net
 * Copyright (c) 2010 Entatonic.net
 * http://entatonic.net
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */


#import <Foundation/Foundation.h>
#import "boxObject.h"

#define RELATION_COUNT_MAX 100

@interface Relations : NSObject {
	NSMutableArray			*boxFrom;			// Line From
	NSMutableArray			*boxTo;				// Line To
	NSMutableArray			*counter;			// Count down counter
}

-(BOOL) addBoxFrom:(boxObject *)boxObjectfrom To:(boxObject *)boxObjectto;
-(void) removeBoxRelation:(int) index;
-(void) replaceObject:(boxObject*) box with:(boxObject*) replacedBox;
-(void) stepAnimation;
-(int) getboxObjectXFrom_index:(int) index;
-(int) getboxObjectYFrom_index:(int) index;
-(int) getboxObjectXTo_index:(int) index;
-(int) getboxObjectYTo_index:(int) index;
-(int) getboxObjectScaleTo_index:(int) index;
-(int) getboxObjectScaleFrom_index:(int) index;

-(int) getRelationCounter:(int) index;
-(int) getCount;
-(BOOL) hasRelation:(boxObject *) box;

@property (nonatomic, retain) NSMutableArray *boxFrom;
@property (nonatomic, retain) NSMutableArray *boxTo;
@property (nonatomic, retain) NSMutableArray *counter;


@end
